print("Hello and thank you for using HivemindFarming!");

hbd = LibStub("HereBeDragons-2.0")

C_ChatInfo.RegisterAddonMessagePrefix("HIVEMIND")

local sendChannel = "GUILD"

local playerName, realm = UnitName("player")

local function roundToFirstDecimal(t)
    return math.floor(t*10)*0.1
end

local function sendPositionMessage(item, channel)
	local x, y, mapID = hbd:GetPlayerZonePosition()
    x = roundToFirstDecimal(x * 100)
    y = roundToFirstDecimal(y * 100)

    C_ChatInfo.SendAddonMessage("HIVEMIND", x .. "," .. y .. "," .. mapID .. "," .. item, channel)
end

local function printHelp()
	print("/hv found ... send test waypoint")
end

local function hivemindChatCommands(msg, editbox)
  if msg == 'found' then
    print('Sending test position...')
    sendPositionMessage("TEST", "GUILD")
  else
    printHelp()
  end
end

SLASH_HIVEMIND1, SLASH_HIVEMIND2 = '/hv', '/hivemind'
SlashCmdList["HIVEMIND"] = hivemindChatCommands   -- add Slash commands to global slash list

local function NoTomTomWarning()
	if(TomTom == nil) then
		print("HivemindFarming Error: this addon requires TomTom to be installed")
		return true
	end
	return false
end

local function CheckIfTooNearOrNoSameMap(dx, dy, dmapID)

	local x, y, mapID = hbd:GetPlayerZonePosition()
	x = x * 100
	y = y * 100

	if(mapID ~= dmapID) then
		return false
	end

	if ( ((x < (dx - 10)) or (x > (dx + 10))) and ((y < (dy - 10)) or (y > (dy + 10))) ) then
		print("player to far away")
		return false
	end

	return true
end

local frame = CreateFrame("FRAME", "HivemindFarmingFrame");
frame:RegisterEvent("CHAT_MSG_ADDON");
frame:RegisterEvent("LOOT_OPENED");
local function eventHandler(self, event, addon, msg, target, dist, sender)
    if(event == 'CHAT_MSG_ADDON') then
      if(addon == "HIVEMIND") then
      	testSend = ((playerName ~= sender) or (playerName == sender and string.match(msg, "TEST")))
        if(target == sendChannel and testSend) then
		  x, y, mapID, item = msg:match("([^,]+),([^,]+),([^,]+),([^,]+)")
		   if (NoTomTomWarning()) then
		   	  return
		   end

		   if(not CheckIfTooNearOrNoSameMap() and not testSend) then
		   	return
		   end

    	   TomTom:AddWaypointToCurrentZone(x,y, msg)
    	   print(item .. " found by " .. sender);
        end
      end
    end
    if(event == 'LOOT_OPENED') then
        for i = 1, GetNumLootItems() do
			local itemLink = GetLootSlotLink(i)
			local itemID = string.match(itemLink, "Hitem:(%d+)")
			if(itemID == nil) then
				print("HivemindFarming Error: You are looting too fast")
				return
			end
			if (itemID == "152510") then -- 152510 is anchor weed id
				sendPositionMessage("Anchor Weed", sendChannel)
			elseif (itemID == "152508") then -- 152510 is winter's kiss id
				sendPositionMessage("Winter's Kiss", sendChannel)
			end
	    end
	end
end
frame:SetScript("OnEvent", eventHandler);